#!/usr/bin/python
#coding:utf-8

import cPickle as p
#import pickle as p
import os
import re
import mmanfunc
from mmanpro import MManProtocol
#import simplejson
import logging

#从文件路径获取version
def GetVersion(path):
    cmd = "svn log "+ReplacePathToSvnUrl(path)
    outlist = os.popen(cmd).readlines()
    isPre = 0
    thisLine = ""

    for line in outlist:
        if re.search(r"^-+$",line.strip()):
            isPre = 1
            continue

        if isPre == 1:
            thisLine = line
            isPre = 2
            break

    if isPre != 2:
        return (0,1)

    versionre = re.search(r"^r\d+\s",thisLine)
    if not versionre:
        return (0,2)
    version = versionre.group().replace("r","").strip()
    return (version,0)

## 
# @brief    将path转换成url
# 
# @param    path
# 
# @return   url
def ReplacePathToSvnUrl(path):
    url = path
    if(mmanfunc.get_ip_address("eth1")=="10.6.207.35"):
        url = path.replace("/usr/local/farm","https://10.6.16.224/isd/isd_happyfarm_rep/isd_happyfarm_proj/trunk")

    return url

## 
# @brief    获取增加version之后的文件名
# 
# @param    filename
# @param    version
# 
# @return   
def GetVerFileName(filename,version):
    prefilere = re.search(r"^.*\.",filename)
    if not prefilere:
        return filename+"_v_" + version

    extre = re.search(r"\.[^\.]+$",filename)
    if not extre:
        return filename+"_v_" + version

    return prefilere.group()[:len(prefilere.group())-1] + "_v_" + version + extre.group();

#def GetP2PKeyId(url,path):
    #cmd = "./create_tpt_for_farm.exe key %s src %s" % (url,path)
    #output = os.popen(cmd).read().replace(r"'",r'"')
    #logging.info(output)
    #try:
        #pydata = simplejson.loads(output)
    #except:
        #return ('','1')
    #return (pydata['outkeyid'],pydata['ret'])


## 
# @brief    获取增加version之后的path
# 
# @param    oldpathtuple
# 
# @return   0   succ
#           1   文件不存在或不是合法路径
#           2   没有版本记录
def GetVersionedPath(oldpathtuple):
    if not os.path.isfile(oldpathtuple[0]):
        return (oldpathtuple[0],1)
    if not os.path.exists(oldpathtuple[0]):
        return (oldpathtuple[0],1)


    if oldpathtuple[1] == 0:
        return (oldpathtuple[0],0)

    vertup = GetVersion(oldpathtuple[0])

    if vertup[1] == 0:
        version = vertup[0]
    else:
        return (oldpathtuple[0],1)

    prepathre = re.search(r"^.*/",oldpathtuple[0])
    if not prepathre:
        return (oldpathtuple[0],1)

    filenamere = re.search(r"[^/]+$",oldpathtuple[0])
    if not filenamere:
        return (oldpathtuple[0],1)

    newFilename = GetVerFileName(filenamere.group(),version)

    newFullPath = prepathre.group() + newFilename

    os.popen("cp "+oldpathtuple[0]+" "+newFullPath)

    if not os.path.exists(newFullPath):
        return (newFullPath,1)

    return (newFullPath,0)

#filename | path | data
def dealFile(body):
    sindex = body.find('|')
    if sindex is -1:
        return -1
    filename = body[0:sindex]
    logging.info(filename)

    nindex = body.find('|',sindex+1)
    if nindex is -1:
        return -1
    path = body[sindex+1:nindex]
    logging.info(path)

    if not os.path.isdir(path):
        os.makedirs(path)
    fullpath = path + filename

    data = body[nindex+1:]

    f = open(fullpath,'wb')
    f.write(data)
    f.close()

    return 0

def DealRequest(recvdata):
    mmanreq = MManProtocol()
    mmanrsp = MManProtocol()

    mmanreq.input(recvdata)
    mmanrsp.cmd = mmanreq.cmd

    if mmanreq.cmd == 1:
        pathverlist = []
        pathtuplist = p.loads(mmanreq.body)
        for pathtuple in pathtuplist:
            newpathtup = GetVersionedPath(pathtuple)
            pathverlist.append(newpathtup)
        #rsp.pathverlist = copy.deepcopy(tmp_pathverlist)
        mmanrsp.body = p.dumps(pathverlist)
    elif mmanreq.cmd == 2:
        path = mmanreq.body
        vertup = GetVersion(path)
        if vertup[1] == 0:
            mmanrsp.body = vertup[0]
        else:
            mmanrsp.ret = 1
    #elif mmanreq.cmd == 3:
        #urlpath = {}
        #urlpath = p.loads(mmanreq.body)
        #url = urlpath['url']
        #path = urlpath['path']
        #p2pkeyid = GetP2PKeyId(url,path)
        #if int(p2pkeyid[1]) == 0:
            #mmanrsp.body = p2pkeyid[0]
        #else:
            #mmanrsp.ret = 1
    elif mmanreq.cmd == 4:
        ret = dealFile(mmanreq.body)
        mmanrsp.ret = ret
    else:
        mmanrsp.ret = 1
    senddata = mmanrsp.output()
    return senddata
